Subject: Re: What's cooking in git.git (Aug 2025, #01; Sun, 3)

From: Jeff King <[email-masked]>
Date: Mon, 4 Aug 2025 11:41:29 -0400

On Mon, Aug 04, 2025 at 04:51:03PM +0200, Patrick Steinhardt wrote:

> > >> * ps/reflog-migrate-fixes (2025-07-29) 9 commits
> > >>  - refs: fix invalid old object IDs when migrating reflogs
> > >>  - refs: stop unsetting REF_HAVE_OLD for log-only updates
> > >>  - refs/files: detect race when generating reflog entry for HEAD
> > >>  - refs: fix identity for migrated reflogs
> > >>  - ident: fix type of string length parameter
> > >>  - builtin/reflog: implement subcommand to write new entries
> > >>  - refs: export `ref_transaction_update_reflog()`
> > >>  - builtin/reflog: improve grouping of subcommands
> > >>  - Documentation/git-reflog: convert to use synopsis type
> > >>  (this branch is used by ps/remote-rename-fix.)
> > >> 
> > >>  "git refs migrate" to migrate the reflog entries from a refs
> > >>  backend to another had a handful of bugs squashed.
> > >> 
> > >>  Will merge to 'next'?
> > >>  source: <[email-masked]>
> > >
> > > I'm happy with this version, so if the above goes in I think this one
> > > here can also be merged.
> > 
> > You have an update for this one.  Perhaps your comments are swapped
> > between these two topics?
> 
> Oh, indeed. Sorry for the confusion.

I just left a rather lengthy review of the split-HEAD patch in v4. I
think hit has a few bugs that we need to address.

I'm not sure if the right answer is to just go back to the v3 version
that simply rejected the racy HEAD update (since that's more or less
what happens now and nobody complains).

If we do want to stick with the "silently skip the racy HEAD update"
strategy from v4, I left some fixes there. But I'd worry more about
maintainability and regressions in the future. I'm not sure if my hacky
"pretend the HEAD is this for splitting" patch is something we'd want to
carry or not. But if so, I think we could at least get a little coverage
in the test suite.

-Peff